

// This C++ file was created by SanEditor

#include "Atomic/CommitStep/CommitStepSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         CommitStepSAN Constructor             
******************************************************************/


CommitStepSAN::CommitStepSAN(){


  Activity* InitialActionList[2]={
    &setTime, //0
    &received  // 1
  };

  BaseGroupClass* InitialGroupList[2]={
    (BaseGroupClass*) &(setTime), 
    (BaseGroupClass*) &(received)
  };

  start_commit = new Place("start_commit" ,0);
  wait = new Place("wait" ,0);
  receive_block = new Place("receive_block" ,0);
  newHeight = new Place("newHeight" ,0);
  int temp_commitTimeint = 0;
  commitTime = new ExtendedPlace<int>("commitTime",temp_commitTimeint);
  BaseStateVariableClass* InitialPlaces[5]={
    start_commit,  // 0
    wait,  // 1
    receive_block,  // 2
    newHeight,  // 3
    commitTime   // 4
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("CommitStep", 5, InitialPlaces, 
                        0, InitialROPlaces, 
                        2, InitialActionList, 2, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[5][2]={ 
    {0,0}, {4,0}, {1,1}, {2,1}, {3,1}
  };
  for(int n=0;n<5;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[3][2]={ 
    {0,0}, {1,1}, {2,1}
  };
  for(int n=0;n<3;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<2;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void CommitStepSAN::CustomInitialization() {

}
CommitStepSAN::~CommitStepSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void CommitStepSAN::assignPlacesToActivitiesInst(){
  setTime.start_commit = (Place*) LocalStateVariables[0];
  setTime.commitTime = (ExtendedPlace<int>*) LocalStateVariables[4];
  received.wait = (Place*) LocalStateVariables[1];
  received.receive_block = (Place*) LocalStateVariables[2];
  received.newHeight = (Place*) LocalStateVariables[3];
}
void CommitStepSAN::assignPlacesToActivitiesTimed(){
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================setTimeActivity========================*/


CommitStepSAN::setTimeActivity::setTimeActivity(){
  ActivityInitialize("setTime",0,Instantaneous , RaceEnabled, 2,1, false);
}

void CommitStepSAN::setTimeActivity::LinkVariables(){
  start_commit->Register(&start_commit_Mobius_Mark);

}

bool CommitStepSAN::setTimeActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(start_commit_Mobius_Mark)) >=1));
  return NewEnabled;
}

double CommitStepSAN::setTimeActivity::Weight(){ 
  return 1;
}

bool CommitStepSAN::setTimeActivity::ReactivationPredicate(){ 
  return false;
}

bool CommitStepSAN::setTimeActivity::ReactivationFunction(){ 
  return false;
}

double CommitStepSAN::setTimeActivity::SampleDistribution(){
  return 0;
}

double* CommitStepSAN::setTimeActivity::ReturnDistributionParameters(){
    return NULL;
}

int CommitStepSAN::setTimeActivity::Rank(){
  return 1;
}

BaseActionClass* CommitStepSAN::setTimeActivity::Fire(){
  (*(start_commit_Mobius_Mark))--;
  commitTime->Mark() = 100;
  return this;
}

/*======================receivedActivity========================*/


CommitStepSAN::receivedActivity::receivedActivity(){
  ActivityInitialize("received",1,Instantaneous , RaceEnabled, 3,2, false);
}

void CommitStepSAN::receivedActivity::LinkVariables(){
  wait->Register(&wait_Mobius_Mark);
  receive_block->Register(&receive_block_Mobius_Mark);
  newHeight->Register(&newHeight_Mobius_Mark);
}

bool CommitStepSAN::receivedActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(wait_Mobius_Mark)) >=1)&&((*(receive_block_Mobius_Mark)) >=1));
  return NewEnabled;
}

double CommitStepSAN::receivedActivity::Weight(){ 
  return 1;
}

bool CommitStepSAN::receivedActivity::ReactivationPredicate(){ 
  return false;
}

bool CommitStepSAN::receivedActivity::ReactivationFunction(){ 
  return false;
}

double CommitStepSAN::receivedActivity::SampleDistribution(){
  return 0;
}

double* CommitStepSAN::receivedActivity::ReturnDistributionParameters(){
    return NULL;
}

int CommitStepSAN::receivedActivity::Rank(){
  return 1;
}

BaseActionClass* CommitStepSAN::receivedActivity::Fire(){
  (*(wait_Mobius_Mark))--;
  (*(receive_block_Mobius_Mark))--;
  (*(newHeight_Mobius_Mark))++;
  return this;
}

