#ifndef CommitStepSAN_H_
#define CommitStepSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/GlobalVariables.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern Long commitTime;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               CommitStepSAN Submodel Definition                   
*********************************************************************/

class CommitStepSAN:public SANModel{
public:

class setTimeActivity:public Activity {
public:

  Place* start_commit;
  short* start_commit_Mobius_Mark;
  ExtendedPlace<int>* commitTime;

  double* TheDistributionParameters;
  setTimeActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // setTimeActivityActivity

class receivedActivity:public Activity {
public:

  Place* wait;
  short* wait_Mobius_Mark;
  Place* receive_block;
  short* receive_block_Mobius_Mark;
  Place* newHeight;
  short* newHeight_Mobius_Mark;

  double* TheDistributionParameters;
  receivedActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // receivedActivityActivity

  //List of user-specified place names
  Place* start_commit;
  Place* wait;
  Place* receive_block;
  Place* newHeight;
  ExtendedPlace<int>* commitTime;

  // Create instances of all actvities
  setTimeActivity setTime;
  receivedActivity received;
  //Create instances of all groups 
  PreselectGroup ImmediateGroup;
  PostselectGroup setTimeGroup;
  PostselectGroup receivedGroup;

  CommitStepSAN();
  ~CommitStepSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end CommitStepSAN

#endif // CommitStepSAN_H_
