#ifndef NewHeightStepSAN_H_
#define NewHeightStepSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/GlobalVariables.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               NewHeightStepSAN Submodel Definition                   
*********************************************************************/

class NewHeightStepSAN:public SANModel{
public:

class waitActivity:public Activity {
public:

  Place* start_newheight;
  short* start_newheight_Mobius_Mark;
  ExtendedPlace<int>* currentHeight;
  Place* start_propose;
  short* start_propose_Mobius_Mark;

  double* TheDistributionParameters;
  waitActivity();
  ~waitActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // waitActivityActivity

  //List of user-specified place names
  Place* start_newheight;
  Place* start_propose;
  ExtendedPlace<int>* currentHeight;

  // Create instances of all actvities
  waitActivity wait;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;

  NewHeightStepSAN();
  ~NewHeightStepSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end NewHeightStepSAN

#endif // NewHeightStepSAN_H_
