#ifndef PreCommitStepSAN_H_
#define PreCommitStepSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/GlobalVariables.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               PreCommitStepSAN Submodel Definition                   
*********************************************************************/

class PreCommitStepSAN:public SANModel{
public:

  //List of user-specified place names
  Place* start_precommit;
  Place* start_propose;
  Place* start_commit;
  Place* start_prevote;

  // Create instances of all actvities
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;

  PreCommitStepSAN();
  ~PreCommitStepSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end PreCommitStepSAN

#endif // PreCommitStepSAN_H_
