

// This C++ file was created by SanEditor

#include "Atomic/ProposeStep/ProposeStepSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         ProposeStepSAN Constructor             
******************************************************************/


ProposeStepSAN::ProposeStepSAN(){


  Activity* InitialActionList[5]={
    &proposable, //0
    &commit, //1
    &prevoting, //2
    &propose, //3
    &timeout  // 4
  };

  BaseGroupClass* InitialGroupList[5]={
    (BaseGroupClass*) &(propose), 
    (BaseGroupClass*) &(timeout), 
    (BaseGroupClass*) &(proposable), 
    (BaseGroupClass*) &(commit), 
    (BaseGroupClass*) &(prevoting)
  };

  start_propose = new Place("start_propose" ,0);
  is_proposer = new Place("is_proposer" ,0);
  propose_i = new Place("propose_i" ,0);
  wait = new Place("wait" ,0);
  start_prevote = new Place("start_prevote" ,0);
  receive_proposal = new Place("receive_proposal" ,0);
  prevote_1 = new Place("prevote_1" ,0);
  prevote_2 = new Place("prevote_2" ,0);
  prevote_3 = new Place("prevote_3" ,0);
  start_commit = new Place("start_commit" ,0);
  int temp_precommit_1int = 0;
  precommit_1 = new ExtendedPlace<int>("precommit_1",temp_precommit_1int);
  int temp_precommit_2int = 0;
  precommit_2 = new ExtendedPlace<int>("precommit_2",temp_precommit_2int);
  int temp_precommit_3int = 0;
  precommit_3 = new ExtendedPlace<int>("precommit_3",temp_precommit_3int);
  BaseStateVariableClass* InitialPlaces[13]={
    start_propose,  // 0
    is_proposer,  // 1
    propose_i,  // 2
    wait,  // 3
    start_prevote,  // 4
    receive_proposal,  // 5
    prevote_1,  // 6
    prevote_2,  // 7
    prevote_3,  // 8
    start_commit,  // 9
    precommit_1,  // 10
    precommit_2,  // 11
    precommit_3   // 12
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("ProposeStep", 13, InitialPlaces, 
                        0, InitialROPlaces, 
                        5, InitialActionList, 5, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[9][2]={ 
    {1,0}, {0,0}, {2,0}, {9,1}, {4,2}, {2,3}, {3,3}, {3,4}, {4,4}
  };
  for(int n=0;n<9;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[8][2]={ 
    {1,0}, {0,0}, {6,2}, {7,2}, {8,2}, {5,2}, {2,3}, {3,4}
  };
  for(int n=0;n<8;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<5;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void ProposeStepSAN::CustomInitialization() {

}
ProposeStepSAN::~ProposeStepSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void ProposeStepSAN::assignPlacesToActivitiesInst(){
  proposable.is_proposer = (Place*) LocalStateVariables[1];
  proposable.start_propose = (Place*) LocalStateVariables[0];
  proposable.propose_i = (Place*) LocalStateVariables[2];
  commit.start_commit = (Place*) LocalStateVariables[9];
  prevoting.prevote_1 = (Place*) LocalStateVariables[6];
  prevoting.prevote_2 = (Place*) LocalStateVariables[7];
  prevoting.prevote_3 = (Place*) LocalStateVariables[8];
  prevoting.receive_proposal = (Place*) LocalStateVariables[5];
  prevoting.start_prevote = (Place*) LocalStateVariables[4];
}
void ProposeStepSAN::assignPlacesToActivitiesTimed(){
  propose.propose_i = (Place*) LocalStateVariables[2];
  propose.wait = (Place*) LocalStateVariables[3];
  timeout.wait = (Place*) LocalStateVariables[3];
  timeout.start_prevote = (Place*) LocalStateVariables[4];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================proposableActivity========================*/


ProposeStepSAN::proposableActivity::proposableActivity(){
  ActivityInitialize("proposable",2,Instantaneous , RaceEnabled, 3,2, false);
}

void ProposeStepSAN::proposableActivity::LinkVariables(){
  is_proposer->Register(&is_proposer_Mobius_Mark);
  start_propose->Register(&start_propose_Mobius_Mark);
  propose_i->Register(&propose_i_Mobius_Mark);
}

bool ProposeStepSAN::proposableActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(is_proposer_Mobius_Mark)) >=1)&&((*(start_propose_Mobius_Mark)) >=1));
  return NewEnabled;
}

double ProposeStepSAN::proposableActivity::Weight(){ 
  return 1;
}

bool ProposeStepSAN::proposableActivity::ReactivationPredicate(){ 
  return false;
}

bool ProposeStepSAN::proposableActivity::ReactivationFunction(){ 
  return false;
}

double ProposeStepSAN::proposableActivity::SampleDistribution(){
  return 0;
}

double* ProposeStepSAN::proposableActivity::ReturnDistributionParameters(){
    return NULL;
}

int ProposeStepSAN::proposableActivity::Rank(){
  return 1;
}

BaseActionClass* ProposeStepSAN::proposableActivity::Fire(){
  (*(is_proposer_Mobius_Mark))--;
  (*(start_propose_Mobius_Mark))--;
  (*(propose_i_Mobius_Mark))++;
  return this;
}

/*======================commitActivity========================*/


ProposeStepSAN::commitActivity::commitActivity(){
  ActivityInitialize("commit",3,Instantaneous , RaceEnabled, 1,0, false);
}

void ProposeStepSAN::commitActivity::LinkVariables(){
  start_commit->Register(&start_commit_Mobius_Mark);
}

bool ProposeStepSAN::commitActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((precommit_successIP()));
  return NewEnabled;
}

    bool ProposeStepSAN::commitActivity::precommit_successIP(){

return false;

return 0;
    }

double ProposeStepSAN::commitActivity::Weight(){ 
  return 1;
}

bool ProposeStepSAN::commitActivity::ReactivationPredicate(){ 
  return false;
}

bool ProposeStepSAN::commitActivity::ReactivationFunction(){ 
  return false;
}

double ProposeStepSAN::commitActivity::SampleDistribution(){
  return 0;
}

double* ProposeStepSAN::commitActivity::ReturnDistributionParameters(){
    return NULL;
}

int ProposeStepSAN::commitActivity::Rank(){
  return 1;
}

BaseActionClass* ProposeStepSAN::commitActivity::Fire(){
  //
  (*(start_commit_Mobius_Mark))++;
  return this;
}

/*======================prevotingActivity========================*/


ProposeStepSAN::prevotingActivity::prevotingActivity(){
  ActivityInitialize("prevoting",4,Instantaneous , RaceEnabled, 1,4, false);
}

void ProposeStepSAN::prevotingActivity::LinkVariables(){
  prevote_1->Register(&prevote_1_Mobius_Mark);
  prevote_2->Register(&prevote_2_Mobius_Mark);
  prevote_3->Register(&prevote_3_Mobius_Mark);
  receive_proposal->Register(&receive_proposal_Mobius_Mark);
  start_prevote->Register(&start_prevote_Mobius_Mark);
}

bool ProposeStepSAN::prevotingActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((prevote_successIP()));
  return NewEnabled;
}

    bool ProposeStepSAN::prevotingActivity::prevote_successIP(){
int total = 3;
int sum = prevote_1->Mark() +
	prevote_2->Mark() +
	prevote_3->Mark();

float minimum = 2/3;
float part = (float)sum / (float)total;


if(receive_proposal->Mark() && part > minimum){
	return true;
}

return false;

return 0;
    }

double ProposeStepSAN::prevotingActivity::Weight(){ 
  return 1;
}

bool ProposeStepSAN::prevotingActivity::ReactivationPredicate(){ 
  return false;
}

bool ProposeStepSAN::prevotingActivity::ReactivationFunction(){ 
  return false;
}

double ProposeStepSAN::prevotingActivity::SampleDistribution(){
  return 0;
}

double* ProposeStepSAN::prevotingActivity::ReturnDistributionParameters(){
    return NULL;
}

int ProposeStepSAN::prevotingActivity::Rank(){
  return 1;
}

BaseActionClass* ProposeStepSAN::prevotingActivity::Fire(){
  ;
  (*(start_prevote_Mobius_Mark))++;
  return this;
}

/*======================proposeActivity========================*/

ProposeStepSAN::proposeActivity::proposeActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("propose",0,Deterministic, RaceEnabled, 2,1, false);
}

ProposeStepSAN::proposeActivity::~proposeActivity(){
  delete[] TheDistributionParameters;
}

void ProposeStepSAN::proposeActivity::LinkVariables(){
  propose_i->Register(&propose_i_Mobius_Mark);
  wait->Register(&wait_Mobius_Mark);
}

bool ProposeStepSAN::proposeActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(propose_i_Mobius_Mark)) >=1));
  return NewEnabled;
}

double ProposeStepSAN::proposeActivity::DeterministicParamValue(){
  return 1;
  return 1.0;  // default rate if none is specified
}

double ProposeStepSAN::proposeActivity::Weight(){ 
  return 1;
}

bool ProposeStepSAN::proposeActivity::ReactivationPredicate(){ 
  return false;
}

bool ProposeStepSAN::proposeActivity::ReactivationFunction(){ 
  return false;
}

double ProposeStepSAN::proposeActivity::SampleDistribution(){
  return 1;
}

double* ProposeStepSAN::proposeActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int ProposeStepSAN::proposeActivity::Rank(){
  return 1;
}

BaseActionClass* ProposeStepSAN::proposeActivity::Fire(){
  (*(propose_i_Mobius_Mark))--;
  (*(wait_Mobius_Mark))++;
  return this;
}

/*======================timeoutActivity========================*/

ProposeStepSAN::timeoutActivity::timeoutActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("timeout",1,Deterministic, RaceEnabled, 2,1, false);
}

ProposeStepSAN::timeoutActivity::~timeoutActivity(){
  delete[] TheDistributionParameters;
}

void ProposeStepSAN::timeoutActivity::LinkVariables(){
  wait->Register(&wait_Mobius_Mark);
  start_prevote->Register(&start_prevote_Mobius_Mark);
}

bool ProposeStepSAN::timeoutActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(wait_Mobius_Mark)) >=1));
  return NewEnabled;
}

double ProposeStepSAN::timeoutActivity::DeterministicParamValue(){
  return 100;
  return 1.0;  // default rate if none is specified
}

double ProposeStepSAN::timeoutActivity::Weight(){ 
  return 1;
}

bool ProposeStepSAN::timeoutActivity::ReactivationPredicate(){ 
  return false;
}

bool ProposeStepSAN::timeoutActivity::ReactivationFunction(){ 
  return false;
}

double ProposeStepSAN::timeoutActivity::SampleDistribution(){
  return 100;
}

double* ProposeStepSAN::timeoutActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int ProposeStepSAN::timeoutActivity::Rank(){
  return 1;
}

BaseActionClass* ProposeStepSAN::timeoutActivity::Fire(){
  (*(wait_Mobius_Mark))--;
  (*(start_prevote_Mobius_Mark))++;
  return this;
}

