

// This C++ file was created by SanEditor

#include "Atomic/Test/TestSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         TestSAN Constructor             
******************************************************************/


TestSAN::TestSAN(){


  Activity* InitialActionList[5]={
    &proposable, //0
    &commit, //1
    &prevoting, //2
    &propose, //3
    &timeout  // 4
  };

  BaseGroupClass* InitialGroupList[5]={
    (BaseGroupClass*) &(propose), 
    (BaseGroupClass*) &(timeout), 
    (BaseGroupClass*) &(proposable), 
    (BaseGroupClass*) &(commit), 
    (BaseGroupClass*) &(prevoting)
  };

  start = new Place("start" ,1);
  is_proposer = new Place("is_proposer" ,0);
  propose_i = new Place("propose_i" ,0);
  wait = new Place("wait" ,0);
  prevote = new Place("prevote" ,0);
  receive_proposal = new Place("receive_proposal" ,0);
  prevote_1 = new Place("prevote_1" ,0);
  prevote_2 = new Place("prevote_2" ,0);
  prevote_3 = new Place("prevote_3" ,0);
  committing = new Place("committing" ,0);
  int temp_precommit_1int = 0;
  precommit_1 = new ExtendedPlace<int>("precommit_1",temp_precommit_1int);
  int temp_precommit_2int = 0;
  precommit_2 = new ExtendedPlace<int>("precommit_2",temp_precommit_2int);
  int temp_precommit_3int = 0;
  precommit_3 = new ExtendedPlace<int>("precommit_3",temp_precommit_3int);
  BaseStateVariableClass* InitialPlaces[13]={
    start,  // 0
    is_proposer,  // 1
    propose_i,  // 2
    wait,  // 3
    prevote,  // 4
    receive_proposal,  // 5
    prevote_1,  // 6
    prevote_2,  // 7
    prevote_3,  // 8
    committing,  // 9
    precommit_1,  // 10
    precommit_2,  // 11
    precommit_3   // 12
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("Test", 13, InitialPlaces, 
                        0, InitialROPlaces, 
                        5, InitialActionList, 5, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[9][2]={ 
    {1,0}, {0,0}, {2,0}, {9,1}, {4,2}, {2,3}, {3,3}, {3,4}, {4,4}
  };
  for(int n=0;n<9;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[8][2]={ 
    {1,0}, {0,0}, {6,2}, {7,2}, {8,2}, {5,2}, {2,3}, {3,4}
  };
  for(int n=0;n<8;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<5;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void TestSAN::CustomInitialization() {

}
TestSAN::~TestSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void TestSAN::assignPlacesToActivitiesInst(){
  proposable.is_proposer = (Place*) LocalStateVariables[1];
  proposable.start = (Place*) LocalStateVariables[0];
  proposable.propose_i = (Place*) LocalStateVariables[2];
  commit.committing = (Place*) LocalStateVariables[9];
  prevoting.prevote_1 = (Place*) LocalStateVariables[6];
  prevoting.prevote_2 = (Place*) LocalStateVariables[7];
  prevoting.prevote_3 = (Place*) LocalStateVariables[8];
  prevoting.receive_proposal = (Place*) LocalStateVariables[5];
  prevoting.prevote = (Place*) LocalStateVariables[4];
}
void TestSAN::assignPlacesToActivitiesTimed(){
  propose.propose_i = (Place*) LocalStateVariables[2];
  propose.wait = (Place*) LocalStateVariables[3];
  timeout.wait = (Place*) LocalStateVariables[3];
  timeout.prevote = (Place*) LocalStateVariables[4];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================proposableActivity========================*/


TestSAN::proposableActivity::proposableActivity(){
  ActivityInitialize("proposable",2,Instantaneous , RaceEnabled, 3,2, false);
}

void TestSAN::proposableActivity::LinkVariables(){
  is_proposer->Register(&is_proposer_Mobius_Mark);
  start->Register(&start_Mobius_Mark);
  propose_i->Register(&propose_i_Mobius_Mark);
}

bool TestSAN::proposableActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(is_proposer_Mobius_Mark)) >=1)&&((*(start_Mobius_Mark)) >=1));
  return NewEnabled;
}

double TestSAN::proposableActivity::Weight(){ 
  return 1;
}

bool TestSAN::proposableActivity::ReactivationPredicate(){ 
  return false;
}

bool TestSAN::proposableActivity::ReactivationFunction(){ 
  return false;
}

double TestSAN::proposableActivity::SampleDistribution(){
  return 0;
}

double* TestSAN::proposableActivity::ReturnDistributionParameters(){
    return NULL;
}

int TestSAN::proposableActivity::Rank(){
  return 1;
}

BaseActionClass* TestSAN::proposableActivity::Fire(){
  (*(is_proposer_Mobius_Mark))--;
  (*(start_Mobius_Mark))--;
  (*(propose_i_Mobius_Mark))++;
  return this;
}

/*======================commitActivity========================*/


TestSAN::commitActivity::commitActivity(){
  ActivityInitialize("commit",3,Instantaneous , RaceEnabled, 1,0, false);
}

void TestSAN::commitActivity::LinkVariables(){
  committing->Register(&committing_Mobius_Mark);
}

bool TestSAN::commitActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((precommit_successIP()));
  return NewEnabled;
}

    bool TestSAN::commitActivity::precommit_successIP(){

return false;

return 0;
    }

double TestSAN::commitActivity::Weight(){ 
  return 1;
}

bool TestSAN::commitActivity::ReactivationPredicate(){ 
  return false;
}

bool TestSAN::commitActivity::ReactivationFunction(){ 
  return false;
}

double TestSAN::commitActivity::SampleDistribution(){
  return 0;
}

double* TestSAN::commitActivity::ReturnDistributionParameters(){
    return NULL;
}

int TestSAN::commitActivity::Rank(){
  return 1;
}

BaseActionClass* TestSAN::commitActivity::Fire(){
  //
  (*(committing_Mobius_Mark))++;
  return this;
}

/*======================prevotingActivity========================*/


TestSAN::prevotingActivity::prevotingActivity(){
  ActivityInitialize("prevoting",4,Instantaneous , RaceEnabled, 1,4, false);
}

void TestSAN::prevotingActivity::LinkVariables(){
  prevote_1->Register(&prevote_1_Mobius_Mark);
  prevote_2->Register(&prevote_2_Mobius_Mark);
  prevote_3->Register(&prevote_3_Mobius_Mark);
  receive_proposal->Register(&receive_proposal_Mobius_Mark);
  prevote->Register(&prevote_Mobius_Mark);
}

bool TestSAN::prevotingActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((prevote_successIP()));
  return NewEnabled;
}

    bool TestSAN::prevotingActivity::prevote_successIP(){
int total = 3;
int sum = prevote_1->Mark() +
	prevote_2->Mark() +
	prevote_3->Mark();

float minimum = 2/3;
float part = (float)sum / (float)total;


if(receive_proposal->Mark() && part > minimum){
	return true;
}

return false;

return 0;
    }

double TestSAN::prevotingActivity::Weight(){ 
  return 1;
}

bool TestSAN::prevotingActivity::ReactivationPredicate(){ 
  return false;
}

bool TestSAN::prevotingActivity::ReactivationFunction(){ 
  return false;
}

double TestSAN::prevotingActivity::SampleDistribution(){
  return 0;
}

double* TestSAN::prevotingActivity::ReturnDistributionParameters(){
    return NULL;
}

int TestSAN::prevotingActivity::Rank(){
  return 1;
}

BaseActionClass* TestSAN::prevotingActivity::Fire(){
  ;
  (*(prevote_Mobius_Mark))++;
  return this;
}

/*======================proposeActivity========================*/

TestSAN::proposeActivity::proposeActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("propose",0,Deterministic, RaceEnabled, 2,1, false);
}

TestSAN::proposeActivity::~proposeActivity(){
  delete[] TheDistributionParameters;
}

void TestSAN::proposeActivity::LinkVariables(){
  propose_i->Register(&propose_i_Mobius_Mark);
  wait->Register(&wait_Mobius_Mark);
}

bool TestSAN::proposeActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(propose_i_Mobius_Mark)) >=1));
  return NewEnabled;
}

double TestSAN::proposeActivity::DeterministicParamValue(){
  return 1;
  return 1.0;  // default rate if none is specified
}

double TestSAN::proposeActivity::Weight(){ 
  return 1;
}

bool TestSAN::proposeActivity::ReactivationPredicate(){ 
  return false;
}

bool TestSAN::proposeActivity::ReactivationFunction(){ 
  return false;
}

double TestSAN::proposeActivity::SampleDistribution(){
  return 1;
}

double* TestSAN::proposeActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int TestSAN::proposeActivity::Rank(){
  return 1;
}

BaseActionClass* TestSAN::proposeActivity::Fire(){
  (*(propose_i_Mobius_Mark))--;
  (*(wait_Mobius_Mark))++;
  return this;
}

/*======================timeoutActivity========================*/

TestSAN::timeoutActivity::timeoutActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("timeout",1,Deterministic, RaceEnabled, 2,1, false);
}

TestSAN::timeoutActivity::~timeoutActivity(){
  delete[] TheDistributionParameters;
}

void TestSAN::timeoutActivity::LinkVariables(){
  wait->Register(&wait_Mobius_Mark);
  prevote->Register(&prevote_Mobius_Mark);
}

bool TestSAN::timeoutActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(wait_Mobius_Mark)) >=1));
  return NewEnabled;
}

double TestSAN::timeoutActivity::DeterministicParamValue(){
  return 100;
  return 1.0;  // default rate if none is specified
}

double TestSAN::timeoutActivity::Weight(){ 
  return 1;
}

bool TestSAN::timeoutActivity::ReactivationPredicate(){ 
  return false;
}

bool TestSAN::timeoutActivity::ReactivationFunction(){ 
  return false;
}

double TestSAN::timeoutActivity::SampleDistribution(){
  return 100;
}

double* TestSAN::timeoutActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int TestSAN::timeoutActivity::Rank(){
  return 1;
}

BaseActionClass* TestSAN::timeoutActivity::Fire(){
  (*(wait_Mobius_Mark))--;
  (*(prevote_Mobius_Mark))++;
  return this;
}

