#include "Composed/network/networkRJ__multiple_instances.h"
char * networkRJ__multiple_instances__SharedNames[] = {"is_proposer"};

networkRJ__multiple_instances::networkRJ__multiple_instances():Rep("multiple_instances", 4, 1, networkRJ__multiple_instances__SharedNames)
{
  InstanceArray = new nodeRJ * [NumModels];
  delete[] ModelArray;
  ModelArray = (BaseModelClass **) InstanceArray;
  for (counter = 0; counter < NumModels; counter++)
    InstanceArray[counter] = new nodeRJ();

  SetupActions();
  if (NumModels == 0) return;

  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************** Initialize local variables ****************
    is_proposer = new Place("is_proposer");
    addSharedPtr(is_proposer, "is_proposer");
    is_proposer->ShareWith(InstanceArray[0]->is_proposer);


    //Share state in submodels
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->is_proposer, is_proposer);
    }
    for (counter = 1; counter < NumModels; counter++) {
      InstanceArray[0]->is_proposer->ShareWith(InstanceArray[counter]->is_proposer);
    }
  }
  Setup("node");
}

networkRJ__multiple_instances::~networkRJ__multiple_instances() {
  if (NumModels == 0) return;
  delete is_proposer;
  for (int i = 0; i < NumModels; i++)
    delete InstanceArray[i];
}

