#include "Composed/node/nodeRJ.h"
char * nodeRJ__SharedNames[] = {"is_proposer", "start_commit", "start_prevote", "start_propose"};

nodeRJ::nodeRJ():Join("Node", 5, 4,nodeRJ__SharedNames) {
  NewHeightStep = new NewHeightStepSAN();
  ModelArray[0] = (BaseModelClass*) NewHeightStep;
  ModelArray[0]->DefineName("NewHeightStep");
  CommitStep = new CommitStepSAN();
  ModelArray[1] = (BaseModelClass*) CommitStep;
  ModelArray[1]->DefineName("CommitStep");
  ProposeStep = new ProposeStepSAN();
  ModelArray[2] = (BaseModelClass*) ProposeStep;
  ModelArray[2]->DefineName("ProposeStep");
  PrevoteStep = new PrevoteStepSAN();
  ModelArray[3] = (BaseModelClass*) PrevoteStep;
  ModelArray[3]->DefineName("PrevoteStep");
  PreCommitStep = new PreCommitStepSAN();
  ModelArray[4] = (BaseModelClass*) PreCommitStep;
  ModelArray[4]->DefineName("PreCommitStep");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    is_proposer = new Place("is_proposer");
    addSharedPtr(is_proposer, "is_proposer" );
    if (ProposeStep->NumStateVariables > 0) {
      is_proposer->ShareWith(getSharableSVPointer(ProposeStep->is_proposer));
      addSharingInfo(getSharableSVPointer(ProposeStep->is_proposer), is_proposer, ProposeStep);
    }

    //Shared variable 1
    start_commit = new Place("start_commit");
    addSharedPtr(start_commit, "start_commit" );
    if (CommitStep->NumStateVariables > 0) {
      start_commit->ShareWith(getSharableSVPointer(CommitStep->start_commit));
      addSharingInfo(getSharableSVPointer(CommitStep->start_commit), start_commit, CommitStep);
    }
    if (ProposeStep->NumStateVariables > 0) {
      start_commit->ShareWith(getSharableSVPointer(ProposeStep->start_commit));
      addSharingInfo(getSharableSVPointer(ProposeStep->start_commit), start_commit, ProposeStep);
    }
    if (PreCommitStep->NumStateVariables > 0) {
      start_commit->ShareWith(getSharableSVPointer(PreCommitStep->start_commit));
      addSharingInfo(getSharableSVPointer(PreCommitStep->start_commit), start_commit, PreCommitStep);
    }

    //Shared variable 2
    start_prevote = new Place("start_prevote");
    addSharedPtr(start_prevote, "start_prevote" );
    if (ProposeStep->NumStateVariables > 0) {
      start_prevote->ShareWith(getSharableSVPointer(ProposeStep->start_prevote));
      addSharingInfo(getSharableSVPointer(ProposeStep->start_prevote), start_prevote, ProposeStep);
    }
    if (PrevoteStep->NumStateVariables > 0) {
      start_prevote->ShareWith(getSharableSVPointer(PrevoteStep->start_prevote));
      addSharingInfo(getSharableSVPointer(PrevoteStep->start_prevote), start_prevote, PrevoteStep);
    }
    if (PreCommitStep->NumStateVariables > 0) {
      start_prevote->ShareWith(getSharableSVPointer(PreCommitStep->start_prevote));
      addSharingInfo(getSharableSVPointer(PreCommitStep->start_prevote), start_prevote, PreCommitStep);
    }

    //Shared variable 3
    start_propose = new Place("start_propose");
    addSharedPtr(start_propose, "start_propose" );
    if (NewHeightStep->NumStateVariables > 0) {
      start_propose->ShareWith(getSharableSVPointer(NewHeightStep->start_propose));
      addSharingInfo(getSharableSVPointer(NewHeightStep->start_propose), start_propose, NewHeightStep);
    }
    if (ProposeStep->NumStateVariables > 0) {
      start_propose->ShareWith(getSharableSVPointer(ProposeStep->start_propose));
      addSharingInfo(getSharableSVPointer(ProposeStep->start_propose), start_propose, ProposeStep);
    }
    if (PreCommitStep->NumStateVariables > 0) {
      start_propose->ShareWith(getSharableSVPointer(PreCommitStep->start_propose));
      addSharingInfo(getSharableSVPointer(PreCommitStep->start_propose), start_propose, PreCommitStep);
    }

  }

  Setup();
}

nodeRJ::~nodeRJ() {
  if (!AllChildrenEmpty()) {
    delete is_proposer;
    delete start_commit;
    delete start_prevote;
    delete start_propose;
  }
  delete NewHeightStep;
  delete CommitStep;
  delete ProposeStep;
  delete PrevoteStep;
  delete PreCommitStep;
}
