#ifndef nodeRJ_H_
#define nodeRJ_H_
#include <math.h>
#include "Cpp/Composer/Join.h"
#include "Cpp/Composer/AllStateVariableTypes.h"
#include "Atomic/NewHeightStep/NewHeightStepSAN.h"
#include "Atomic/CommitStep/CommitStepSAN.h"
#include "Atomic/ProposeStep/ProposeStepSAN.h"
#include "Atomic/PrevoteStep/PrevoteStepSAN.h"
#include "Atomic/PreCommitStep/PreCommitStepSAN.h"

//State variable headers
#include "Cpp/BaseClasses/SAN/Place.h"

class nodeRJ: public Join {
 public:
  NewHeightStepSAN * NewHeightStep;
  CommitStepSAN * CommitStep;
  ProposeStepSAN * ProposeStep;
  PrevoteStepSAN * PrevoteStep;
  PreCommitStepSAN * PreCommitStep;
  Place * is_proposer;
  Place * start_commit;
  Place * start_prevote;
  Place * start_propose;

  nodeRJ();
  ~nodeRJ();
};

#endif
